--This plugin is made by Hemant. Special thanks to Ashish Kaushik for assistance. 
require "import"
import "android.content.Intent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"

local editText = service.getEditText()

if not editText then

service.asyncSpeak("Text Box Not Found")

return
end
local context = service.getApplicationContext()

local speechRec = SpeechRecognizer.createSpeechRecognizer(context)



local changeTable = {


["कंट्री स्क्रीन रीडर"] = "कॉमेंट्री स्क्रीन रीडर",
["धन्यवाद"] = "ढणयवाद",

["उसे"] = "उस",
["जॉर्ज"] = "JAWS",
["एनवीडीया"] = "NVDA",
[""] = "",
[""] = "",
[""] = "",
[""] = "",
[""] = "",
[""] = "",
["रूपी सिंबल"] = "₹",
["रुपीस सिंबल"]= "₹",
["अल्पविराम"] = ", ",
["प्रश्न चीन"] = "? ",
["प्रश्न चिन्ह"] = "? ",
["प्रश्नवाचक"] = "? ",
["प्रश्न वाचक"] = "? ",
["विस्मय"] = "! ",
["विश्व में"] = "! ",
["बैंक सिंबल"] = "! ",
["न्यूलाइन"] = "\n",
["नई लाइन"] = "\n",
["न्यू लाइन"] = "\n",
["स्पेस"] = " ",
["थम्स अप"] = "👍",
["रेड हार्ट"] = "❤",
["रेड हॉट"] = "❤",
["फोल्डेड हैंड्स"] = "🙏",
["अति सुंदर"] = "👌",
["डॉट डॉट"] = "...",
["स्माइली फेस"] = "☺",

["स्माइली 1"] = "☺",
["स्माइली एक"] = "☺",
["स्माइली one"] = "☺",

["स्माइली 2"] = "😊",
["स्माइली दो"] = "😊",
["स्माइली two"] = "😊",

["स्माइली 3"] = "😂",
["स्माइली तीन"] = "😂",
["स्माइली three"] = "😂",

["स्माइली 4"] = "🤣",
["स्माइली चार"] = "🤣",
["स्माइली four"] = "🤣",

["स्माइली 5"] = "🙂",
["स्माइली पांच"] = "🙂",
["स्माइली five"] = "🙂",

["स्माइली 6"] = "😍",
["स्माइली छह"] = "😍",
["स्माइली six"] = "😍",

["स्माइली 7"] = "🥰",
["स्माइली सात"] = "🥰",
["स्माइली seven"] = "🥰",

["स्माइली 8"] = "😌",
["स्माइली आठ"] = "😌",
["स्माइली eight"] = "😌",

["स्माइली 9"] = "😙",
["स्माइली ना"] = "😙",
["स्माइली nine"] = "😙",

["इमोजी 1"] = "👏",
["इमोजी एक"] = "👏",
["इमोजी one"] = "👏",

["इमोजी 2"] = "💯",
["इमोजी दो"] = "💯",
["इमोजी two"] = "💯",

["इमोजी 3"] = "🤝",
["इमोजी तीन"] = "🤝",
["इमोजी three"] = "🤝",

["इमोजी 4"] = "👐",
["इमोजी चार"] = "👐",
["इमोजी four"] = "👐",

["इमोजी 5"] = "🤲",
["इमोजी पांच"] = "🤲",
["इमोजी five"] = "🤲",

["इमोजी 6"] = "👎",
["इमोजी छह"] = "👎",
["इमोजी six"] = "👎",

["इमोजी 7"] = "👊",
["इमोजी सात"] = "👊",
["इमोजी seven"] = "👊",

["इमोजी 8"] = "👉",
["इमोजी आठ"] = "👉",
["इमोजी eight"] = "👉",

["इमोजी 9"] = "👋",
["इमोजी ना"] = "👋",
["इमोजी nine"] = "👋",

["सिंबल 1"] = "🔳",
["सिंबल एक"] = "🔳",
["सिंबल one"] = "🔳",

["सिंबल 2"] = "🔲",
["सिंबल दो"] = "🔲",
["सिंबल two"] = "🔲",

["सिंबल 3"] = "▪",
["सिंबल तीन"] = "▪",
["सिंबल three"] = "▪",

["सिंबल 4"] = "🆗",
["सिंबल चार"] = "🆗",
["सिंबल four"] = "🆗",

["सिंबल 5"] = "💮",
["सिंबल पांच"] = "💮",
["सिंबल five"] = "💮",

["सिंबल 6"] = "➡",
["सिंबल छह"] = "➡",
["सिंबल six"] = "➡",

["सिंबल 7"] = "✔",
["सिंबल सात"] = "✔",
["सिंबल seven"] = "✔",

["सिंबल 8"] = "🎊",
["सिंबल आठ"] = "🎊",
["सिंबल eight"] = "🎊",

["सिंबल 9"] = "🎉",
["सिंबल ना"] = "🎉",
["सिंबल nine"] = "🎉",

[""] = "",
}



local listener = RecognitionListener {
onResults = function(results)
local resultsArray = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
if resultsArray and resultsArray.size() > 0 then
local spokenText = resultsArray.get(0)
for rawWord, newWord in pairs(changeTable) do
spokenText = spokenText:gsub(rawWord, newWord)
end
spokenText = spokenText:gsub("%s([?,!])", "%1") -- Trim spaces before specific punctuation
local lastChars = spokenText:match("[.?!,।\n👍❤🙏👌%s]+$") -- Find the last characters that match the pattern
if not lastChars then
spokenText = spokenText .. ". \n"
end
service.insertText(editText, spokenText)
service.speak(spokenText)
end
speechRec.destroy()
end,
onError = function()
service.asyncSpeak("I did not understand your message")
speechRec.destroy()
return false
end,
}

local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "hi-IN")

speechRec.setRecognitionListener(listener)
speechRec.startListening(intent)







--["नहींपंक्ति"] = "\n",
--["नई पंक्ति"] = "\n",
--["नहीं पंक्ति"] = "\n",
--["नहीं बनती"] = "\n",
--[" कोमा"] = ", ",
-- ["कामा"] = ", ",
--[" कॉम"] = ", ",
--[" कमा "] = ", ",

--।